#include "convcoder.h"


void ConvCoder(char *input, char *output, int len, char g[CONVCODER_MAXRATE][CONVCODER_NUMREGISTERS+1], int rate) {

    int m,K;         
    long t, tt;     
    int i, j, k;        
    char shift_reg[CONVCODER_NUMREGISTERS+1];
    int sr_head;
    char out[CONVCODER_MAXRATE];

    m = CONVCODER_NUMREGISTERS;
    K = CONVCODER_NUMREGISTERS+1;

    /* Initialize the shift register */
    for (j = 0; j < K; j++) {
        shift_reg[j] = 0;
    }
 
    sr_head = 0;

    /* initialize the channel symbol output index */
    tt = 0;

    /* Now start the encoding process */
    /* compute the upper and lower mod-two adder outputs, one bit at a time */
    for (t = 0; t < len + m; t++) {
    	if (t<len)
	        shift_reg[sr_head] = input[t];
	    else
	    	shift_reg[sr_head] = 0;
        for (i=0;i<rate;i++)
        	out[i]=0;
        for (j = 0; j < K; j++) {
            k = (j + sr_head) % K;
            for (i=0;i<rate;i++)
	            out[i] ^= shift_reg[k] & g[i][j];
	    }

        /* write the upper and lower xor gate outputs as channel symbols */
        for (i=0;i<rate;i++) {
	        output[tt] = out[i];
	        tt++;
	    }
       
        sr_head -= 1;    /* equivalent to shifting everything right one place */
        if (sr_head < 0) /* but make sure we adjust pointer modulo K */
            sr_head = m;

    }
}
