
#include <phal_sw_api.h>
#include <swapi_utils.h>

#include "typetools.h"

#include "itf_types.h"
#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#include "convcoder.h"

//#define TEST

/* conections poly */
char g[2][CONVCODER_MAXRATE][CONVCODER_NUMREGISTERS+1]=	{\
	1,0,1,1,1,0,0,0,1,\
	1,1,1,1,0,1,0,1,1,\
					  \
	1,0,1,1,0,1,1,1,1,\
	1,1,0,1,1,0,0,1,1,\
	1,1,1,0,0,1,0,0,1 \
	};

int longblock,numblocks,coderate;
int configured;

char input_bits[INPUT_MAX_DATA*8];


#ifdef TEST
char tmp[OUTPUT_MAX_DATA];
#endif


int process_input(int len)
{
    int l;
    char *wptr;
    int rpm,wpm;

    if (!configured)
        return;

    if (len!=typeSizeArray(TYPE_BITSTREAM,longblock*numblocks)) {
        printf("ConvCoder: Invalid input length: longblock %d numblocks %d len %d\n",longblock,numblocks,len);
        return 0;
    }

    wptr=output_data;
    rpm=0;
    wpm=0;

    
    for (l=0;l<numblocks;l++) {
        ConvCoder(input_data,wptr,longblock,g[coderate-2],coderate);
        #ifdef TEST
            ConvDecoder(wptr,tmp,longblock,g[coderate-2],coderate);
            if (memcmp(wptr,tmp,longblock)) {
                printf("error\n");
            } else {
                printf("ok\n");
            }
        #endif
        wptr+=coderate*(longblock+CONVCODER_NUMREGISTERS);
        wpm+=coderate*(longblock+CONVCODER_NUMREGISTERS);
        rpm+=longblock;
        break;
    }
    
    //memcpy(output_data,input_data,len);
    bin2char(input_data,output_data,longblock*numblocks);
    wpm=numblocks*coderate*(longblock+CONVCODER_NUMREGISTERS);
    
    /* send throught output */
    SendItf(0,typeSizeArray(TYPE_BITSTREAM,wpm));

    return 1;
}

int process_control(int len) {
    configured=1;
    longblock=ctrlpkt.long_block;
    numblocks=ctrlpkt.num_blocks;
    coderate=ctrlpkt.code_rate;
    printf("ConvCoder: longblock=%d numblocks=%d coderate=%d\n",longblock,numblocks,coderate);
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    configured=0;
    longblock=0;
    numblocks=0;
    coderate=0;
    return 1;
}


void ConfigInterfaces(){}

