
#include <phal_sw_api.h>
#include <swapi_utils.h>

#include "typetools.h"

#include "itf_types.h"
#include "inputs.h"
#include "outputs.h"
#include "stats.h"

#include "convdecoder.h"

/* conections poly */
char g[2][CONVCODER_MAXRATE][CONVCODER_NUMREGISTERS+1]=	{\
	1,0,1,1,1,0,0,0,1,\
	1,1,1,1,0,1,0,1,1,\
					  \
	1,0,1,1,0,1,1,1,1,\
	1,1,0,1,1,0,0,1,1,\
	1,1,1,0,0,1,0,0,1 \
	};

int longblock,numblocks,coderate;
int configured;

char output_bits[OUTPUT_MAX_DATA];

int process_input(int len)
{
    int l,i;
    char *wptr;
    int rpm,wpm;

    if (!configured)
        return;

    if (len!=typeSizeArray(TYPE_BITSTREAM,(coderate*(longblock+CONVCODER_NUMREGISTERS))*numblocks)) {
        printf("ConvDECoder: Invalid input length: longblock %d numblocks %d len %d\n",longblock,numblocks,len);
        return 0;
    }

    wptr=output_bits;
    rpm=0;
    wpm=0;
    
    /* decide */
    for (i=0;i<len;i++) {
        input_data[i]=(input_data[i]>0)?1:0;
    }
   
    for (l=0;l<numblocks;l++) {
        ConvDecoder(&input_data[rpm],wptr,longblock,g[coderate-2],coderate);
        wptr+=longblock;
        wpm+=longblock;
        rpm+=coderate*(longblock+CONVCODER_NUMREGISTERS);
        break;
    }

    char2bin(output_bits,output_data,longblock*numblocks);
    wpm=longblock*numblocks;
    
    /* send throught output */
    SendItf(0,typeSizeArray(TYPE_BITSTREAM,wpm));

    return 1;
}

int process_control(int len) {
    configured=1;
    longblock=ctrlpkt.long_block;
    numblocks=ctrlpkt.num_blocks;
    coderate=ctrlpkt.code_rate;
    printf("ConvDECoder: longblock=%d numblocks=%d coderate=%d\n",longblock,numblocks,coderate);
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    configured=0;
    longblock=0;
    numblocks=0;
    coderate=0;
    return 1;
}


void ConfigInterfaces(){}

