/** ALOE headers
 */
#include <phal_sw_api.h>
#include <math.h>
#include <swapi_utils.h>

#include "typetools.h"

#include "itf_types.h"
#include "inputs.h"
#include "outputs.h"
#include "stats.h"

int rows,cols;
int configured;

struct interleaver_h cur_ctrl;

int input_i[INPUT_MAX_DATA*8],output_i[OUTPUT_MAX_DATA*8];

int process_input(int len)
{
    int i;
    char *inc;
    short *ins;
    int *ini;
    float *inf;

    if (!configured)
        return;

    if (len!=typeSizeArray(datatype,ctrlpkt.input_length)) {
        printf("Interleaver: rows=%d cols=%d expected len=%d len=%d\n",rows,cols,typeSizeArray(datatype,ctrlpkt.input_length),len);
        return 0;
    }

    type2int(input_data,input_i,ctrlpkt.input_length,datatype);
    
    /** add padding symbols */
    for (i=ctrlpkt.input_length;i<rows*cols;i++) {
        input_i[i]=(int) ctrlpkt.padding_symbol;
    }

    Interleaving(input_i,output_i,&cur_ctrl,datatype);

    int2type(output_i,output_data,ctrlpkt.input_length,datatype);
    
    /* send throught output */
    SendItf(0,typeSizeArray(datatype,ctrlpkt.output_length));

    return 1;
}


int process_control(int len) {
    configured=1;
    rows=ctrlpkt.rows;
    cols=ctrlpkt.cols;
    memcpy(&cur_ctrl,&ctrlpkt,sizeof(struct interleaver_h));
    xprintf("Interleaver: rows=%d, cols=%d\n",rows,cols);
}

/** Run function.
 * @return 1 if ok, 0 if error
 */
int RunCustom()
{
    return 1;
}

int InitCustom()
{
    configured=0;
    rows=0;
    cols=0;
    return 1;
}


void ConfigInterfaces()
{
    
}



